
/** TP 5ETI - CPE Lyon - 2011/2012 */

#include <scene.hpp>

#include <GL/glut.h>
#include <opengl_drawer.hpp>
#include <texture.hpp>
#include <mesh_io_off.hpp>
#include <cmath>

using namespace cpe;

void scene::load_model()
{
    creation_damier();


    //charge les objets de la scène une seule fois

    opengl_drawer::generate_texture(2,"data/pic.ppm");
    mesh_0=cpe::mesh::load_off_file("data/quad.off");
    mesh_0.scale_unity();
    mesh_0.scale(0.5);
    mesh_0.apply(matrix3::rotation(v3(1,0,0),M_PI/2.0));
    mesh_0.apply(matrix3::rotation(v3(0,0,1),-M_PI/4.0));
    mesh_0.translate(v3(0.5,-0.5,0.25));
    mesh_0_normal=mesh_0.normal_vertex();


    mesh_1=mesh::load_off_file("data/dino_1.off");
    mesh_1.scale_unity();
    mesh_1.apply(matrix3::rotation(v3(1,0,0),M_PI/2.0));
    mesh_1.apply(matrix3::rotation(v3(0,0,1),M_PI/6.0));
    mesh_1.translate(v3(-0.4,0.2,0.22));
    mesh_1_normal=mesh_1.normal_vertex();

}

void scene::draw_scene()
{
    //affichage de la scène

    glEnable(GL_LIGHTING);
    glEnable(GL_TEXTURE_2D);


    //affiche le maillage 0
    glColor3d(0.9,0.9,0.9);
    glBindTexture(GL_TEXTURE_2D,2);
    cpe::opengl_drawer::draw(mesh_0,mesh_0_normal);

    //affiche le maillage 1
    glColor3d(0.7,0.8,0.6);
    cpe::opengl_drawer::draw(mesh_1,mesh_1_normal);



    affichage_damier();

}

void scene::creation_damier()
{
    opengl_drawer::generate_texture(1,"data/damier.ppm");
    mesh_plan=mesh::load_off_file("data/quad.off");
    mesh_plan.scale_unity();
    mesh_plan.scale(2.0);
    mesh_plan_normal=mesh_plan.normal_vertex();
}

void scene::affichage_damier()
{
    //affiche le plan avec la texture
    glBindTexture(GL_TEXTURE_2D,1);
    glColor3d(0.9,0.9,0.9);
    opengl_drawer::draw(mesh_plan,mesh_plan_normal);

    //affiche les axes
    glDisable(GL_LIGHTING);
    glBegin(GL_LINES);
    glColor3d(1,0,0);
    glVertex3d(0,0,0);
    glVertex3d(1.25,0,0);

    glColor3d(0,1,0);
    glVertex3d(0,0,0);
    glVertex3d(0,1.25,0);

    glColor3d(0,0,1);
    glVertex3d(0,0,0);
    glVertex3d(0,0,1.25);
    glEnd();
}
